
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>和我一起开发Android应用（三）——“悦词-i背单词”词典功能实现 / 憋错料</title>

    <meta name="description" content="和我一起开发Android应用（三）——“悦词-i背单词”词典功能实现 接上一讲.本节我们把词典功能基本实现,首先上一个效果图,我发现大家比较关心界面方面的东西,我之前写的一个关于QQ界面的项目就很受欢迎,当然我现在能写出远比那个好看的界面.但是我想一个应用最核心的东西不完全在界面,一个好的创意,一个好的后台服务才是成功的关键,这也是我不断学习的方向. 另外我发现在百度搜“悦词背单词91”搜索结果全是我在博客园的博文了...所以我把这个项目在91应用市场的下载地址粘上来吧,十分欢迎大家试用一下,有什么改进的意见请写在下面的评论里!地址:http://apk.91.c">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">和我一起开发Android应用（三）——“悦词-i背单词”词典功能实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　接上一讲。本节我们把词典功能基本实现，首先上一个效果图，我发现大家比较关心界面方面的东西，我之前写的一个关于QQ界面的项目就很受欢迎，当然我现在能写出远比那个好看的界面。但是我想一个应用最核心的东西不完全在界面，一个好的创意，一个好的后台服务才是成功的关键，这也是我不断学习的方向。</p>
<p>　　另外我发现在百度搜&ldquo;悦词背单词91&rdquo;搜索结果全是我在博客园的博文了。。。所以我把这个项目在91应用市场的下载地址粘上来吧，十分欢迎大家试用一下，有什么改进的意见请写在下面的评论里！地址：<a href="http://apk.91.com/Soft/Android/com.carlos.yueci-4.html" rel="external nofollow noreferrer">http://apk.91.com/Soft/Android/com.carlos.yueci-4.html</a></p>
<p>　　今天我们就实现这个界面，一个能查词的词典。</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzU1MjcwNC8yMDE0MDgvMjYxOTE3NTIyOTg1OTM3LnBuZw==.jpg" /></p>
<p>　　为了明确思路，把上一节的项目功能分析拷贝过来：</p>
<p>　功能分析：</p>
<p>功能1、查单词。</p>
<p>　　实现方法：金山词霸开放平台提供了一个开放API，通过Http访问金山词霸API提供的URL，可以获得一个XML文档，这个文档就包含了要查询的单词的释义、例句、音标、声音的地址。通过解析该XML就可以获得单词的所有信息。</p>
<p>　　所用到的技术：</p>
<p>　　　　1）Http访问网络，并下载网络文件</p>
<p>　　　　2）对SD卡进行操作，从SD卡（这里的SD卡是指手机默认的存储卡，因为有些手机既能能插SD卡又有内部存储，这里不涉及这个问题）中读取文件，和把从网络下载的文件存进SD卡。</p>
<p>　　　　3）解析XML文件</p>
<p>　　　　4）播放音乐（这个我后来封装成了一个类，专门从网络上查询某个单词，解析XML文件，并且将下载的Mp3文件存在SD卡中，然后播放该Mp3文件）</p>
<p>　　　　5）数据库，这里涉及到第一个数据库，每查找一个单词之后，就会将该单词和释义存储到一个SQLite数据库中。这样一来，下一次查找这个单词时，先访问数据库，看看数据库中有没有这个单词，若有，就不用访问网络了。</p>
<p>　　根据上面的分析，可见我们已经实现了Http网络模块，XML文件解析，还有三个内容，我们先实现这三个功能，然后再把UI搭建起来。</p>
<p>（一）后台功能实现</p>
<p>　　　　一、对SD进行操作。FileUtils类，一个专门用于实现讲输入流写入文件，从文件中获得输入流的类，当我们从网上搜索一个单词后，会把它对应的音频Mp3存储在本地的一个文件夹，这样当我们再查这个单词或者在背单词时遇到这个单词时，就不用再访问网络了。</p>
<pre>package com.carlos.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import android.os.Environment;

public class FileUtils {
    private String SDPATH;  

    public FileUtils(){
        SDPATH=Environment.getExternalStorageDirectory()+"/";

        //System.out.println(Environment.getExternalStorageDirectory().getAbsolutePath());
    }

    //创建文件,一定不会返回空
    /**
     *
     * @param path 直接创建文件即可，无需考虑文件夹有没有创建,若文件已存在返回null
     * @param fileName
     * @return
     */
    public File createSDFile(String path,String fileName){
        File file=null;
        createSDDir(path);
        try{
        file=new File(SDPATH+path+fileName);
        if(file.exists() &amp;&amp; file.isFile()){
            return null;
        }
        file.createNewFile();  //创建文件

        }catch(Exception e){
            e.printStackTrace();
        }
        return file;
    }

    //创建目录,如果存在同名文件夹则返回该文件夹，否则创建文件
    public File createSDDir(String dirName){
        File dir=new File(SDPATH+dirName);
        if(dir.exists() &amp;&amp; dir.isDirectory()){
            return dir;
        }
        dir.mkdirs();  //可创建多级文件夹
        return dir;
    }

    //这里写相对目录
    public ArrayList&lt;String&gt; listContentsOfFile(String path){
        ArrayList&lt;String&gt; list=new ArrayList&lt;String&gt;();
        File file=new File(SDPATH+path);
        File[] fileList=file.listFiles();
        if(fileList==null)
            return list;
        for(int i=0; i&lt;fileList.length;i++){
            System.out.println(fileList[i].getName());
        }
        return list;
    }

    //判断SD卡文件夹是否存在
    public boolean isFileExist(String path,String fileName){
        File file=new File(SDPATH+path+fileName);
        return file.exists();
    }

    //获得文件输入流
    public InputStream getInputStreamFromFile(String path,String fileName){
        InputStream input=null;
        File file=new File(SDPATH+path+fileName);
        if(file.exists()==false)
            return null;
        try {
            input=new FileInputStream(file);
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch bloc
            e.printStackTrace();
            return null;
        }

        return input;
    }

    /**
     *
     * @param in
     * @param path  文件存储的相对路径
     * @param fileName
     * @return
     */
    public boolean saveInputStreamToFile(InputStream in, String path,String fileName ){
        File file=createSDFile(path,fileName); //相对路径即可
        int length=0;
        if(file==null)
            return true;  //其实这里的情况是文件已存在
        byte[] buffer=new byte[1024];
        FileOutputStream fOut=null;
        try {
            fOut=new FileOutputStream(file);

            while((length=in.read(buffer))!=-1){          //要利用read返回的实际成功读取的字节数，将buffer写入文件，否则将会出现错误的字节
                fOut.write(buffer, 0, length);
            }

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return false;
        }finally{
            try {
                fOut.close();
            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                return false;
            }
        }
        return true;
    }

    public String getSDRootPath(){
        return Environment.getExternalStorageDirectory().getAbsolutePath()+"/";
    }

    public String getSDPATH() {
        return SDPATH;
    }

    public void setSDPATH(String sDPATH) {
        SDPATH = sDPATH;
    }

}</pre>
<p>各个函数的功能已经有说明，这个属于一个工具类，可无需改动使用。</p>
<p>　　　　二、数据库，用于存放所查的单词的单词、音标、释义、例句</p>
<p>1、首先需创建一个DataBaseHelper类，继承SQLiteOpenHelper类：</p>
<pre>package com.carlos.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;

public class DataBaseHelperDict extends SQLiteOpenHelper{

    public Context mContext=null;
    public String tableName=null;
    public static int VERSION=1;
    public DataBaseHelperDict(Context context, String name, CursorFactory factory,
            int version) {
        super(context, name, factory, version);
        // TODO Auto-generated constructor stub
        mContext=context;
        tableName=name;
    }   

    public DataBaseHelperDict(Context context, String name, CursorFactory factory){
        this(context,name,factory,VERSION);
        mContext=context;
        tableName=name;
    }

    public DataBaseHelperDict(Context context, String name){
        this(context,name,null);
        mContext=context;
        tableName=name;
    };

    @Override
    public void onCreate(SQLiteDatabase db) {
        // TODO Auto-generated method stub
        db.execSQL("create table dict(word text,pse text,prone text,psa text,prona text," +
                "interpret text, sentorig text, senttrans text)");

    }

    @Override
    public void onUpgrade(SQLiteDatabase arg0, int arg1, int arg2) {
        // TODO Auto-generated method stub

    }

}</pre>
<p>　　这是一个非常简单的类，在onCreate方法中我们需要用到类似JDBC的语言创建一个表table</p>
<pre>    public void onCreate(SQLiteDatabase db) {
        // TODO Auto-generated method stub
        db.execSQL("create table dict(word text,pse text,prone text,psa text,prona text," +
                "interpret text, sentorig text, senttrans text)");

    }</pre>
<p>其中word 单词,pse 英式音标,prone 英式发音地址,psa 美式音标,prona 美式发音地址，interpret 翻译, sentorig 利用英文, senttrans 例句中文</p>
<p>这8项是这个表的8列，用于存储一个单词的所有信息。</p>
<p>　那么接下来的问题便是，有了这个数据库我们怎么操作它呢？为此我封装了一个词典类Dict，这个类具有和词典一样的功能：在词典中查找一个单词，查找一个单词的翻译，或例句，从网络上下载某个单词的信息，将某个单词添加到词典中。一些细节的说明在代码中有注释</p>
<pre>package com.carlos.wordcontainer;

import java.io.BufferedReader;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URLEncoder;
import java.util.ArrayList;

import java.util.LinkedList;

import org.xml.sax.InputSource; 

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;

import com.carlos.database.DataBaseHelperDict;
import com.carlos.internet.NetOperator;
import com.carlos.text_parser.JinShanContentHandler;
import com.carlos.text_parser.XMLParser;
import com.carlos.utils.FileUtils;

public class Dict {
    public Context context=null;
    public String tableName=null;
    private DataBaseHelperDict dbHelper=null;
    private SQLiteDatabase dbR=null,dbW=null;

    public Dict(Context context,String tableName){
        this.context=context;
        this.tableName=tableName;
        dbHelper=new DataBaseHelperDict(context, tableName);     //这里要用到前面的DataBaseHelper类，在Dict的构造方法中实例化该类，                                                                 //并且调用下面两个方法获得dbR和dbW,用于完成对数据库的增删改查操作。                                                                 //这里吧dbR dbW作为成员变量目的是避免反复实例化dbR  dbW造成数据库指针泄露。
        dbR=dbHelper.getReadableDatabase();
        dbW=dbHelper.getWritableDatabase();

    }

    @Override
    protected void finalize() throws Throwable {      //在该对象销毁时，释放dbR和dbW
        // TODO Auto-generated method stub
        dbR.close();
        dbW.close();
        dbHelper.close();
        super.finalize();

    }

//将包含单词信息的WordValue对象添加进数据库，这里使用了dbW的insert方法，需要创建一个ContentValue对象存放键值对
    public void insertWordToDict(WordValue w, boolean isOverWrite){
        if(w==null){          //避免空指针异常
            return;
        }
        Cursor cursor=null;
        try{
        ContentValues values=new ContentValues();
        values.put("word",w.getWord() );
        values.put("pse", w.getPsE());
        values.put("prone",w.getPronE());
        values.put("psa", w.getPsA());
        values.put("prona", w.getPronA());
        values.put("interpret",w.getInterpret());
        values.put("sentorig", w.getSentOrig());
        values.put("senttrans", w.getSentTrans());
        cursor=dbR.query(tableName, new String[]{"word"}, "word=?", new String[]{w.getWord()}, null, null, null);
        if(cursor.getCount()&gt;0){
            if(isOverWrite==false)//首先看看数据库中有没有这个单词，若词典库中已经有了这一个单词，所以不再操作
                return;
            else{              //执行更新操作
                dbW.update(tableName, values, "word=?",new String[]{ w.getWord()});
            }
        }else{
            dbW.insert(tableName, null, values);
            //这里可能会发生空指针异常，到时候考虑
        }
        }catch(Exception e){

        }finally{
            if(cursor!=null)
                cursor.close();
        }

    }
    //判断数据库中是否存在某个单词
    public boolean isWordExist(String word){

        Cursor cursor=null;
        try{
        cursor=dbR.query(tableName, new String[]{"word"}, "word=?", new String[]{word}, null, null, null);
        if(cursor.getCount()&gt;0){
            cursor.close();
            return true;
        }else{
            cursor.close();
            return false;
        }
        }finally{
            if(cursor!=null)
                cursor.close();
        }

    }
    //从单词库中获得某个单词的信息，如果词库中没有改单词，那么返回null
    public WordValue getWordFromDict(String searchedWord){
        WordValue w=new WordValue();//预防空指针异常
//        db.execSQL("create table dict(word text,pse text,prone text,psa text,prona text," +
//                "interpret text, sentorig text, senttrans text)");
        String[] columns=new String[]{"word",
                "pse","prone","psa","prona","interpret","sentorig","senttrans"};

        String[] strArray=new String[8];
        Cursor cursor=dbR.query(tableName, columns, "word=?", new String[]{searchedWord}, null, null, null);
        while(cursor.moveToNext()){
            for(int i=0;i&lt;strArray.length;i++){
                strArray[i]=cursor.getString(cursor.getColumnIndex(columns[i]));

            }
            w=new WordValue(strArray[0],strArray[1],strArray[2],strArray[3],strArray[4],strArray[5],strArray[6],strArray[7]);
        }
        cursor.close();
        return w;
    }
    //从网络查找某个单词，并且返回一个含有单词信息的WordValue对象，这个方法在第二讲的最后提过
    public WordValue getWordFromInternet(String searchedWord){
        WordValue wordValue=null;
        String tempWord=searchedWord;
        if(tempWord==null&amp;&amp; tempWord.equals(""))
            return null;
        char[] array=tempWord.toCharArray();
        if(array[0]&gt;256)           //是中文，或其他语言的的简略判断
            tempWord="_"+URLEncoder.encode(tempWord);
        InputStream in=null;
        String str=null;
        try{
            String tempUrl=NetOperator.iCiBaURL1+tempWord+NetOperator.iCiBaURL2;
            in=NetOperator.getInputStreamByUrl(tempUrl);
            if(in!=null){
                new FileUtils().saveInputStreamToFile(in, "", "gfdgf.txt");
                XMLParser xmlParser=new XMLParser();
                InputStreamReader reader=new InputStreamReader(in,"utf-8");
                JinShanContentHandler contentHandler=new JinShanContentHandler();
                xmlParser.parseJinShanXml(contentHandler, new InputSource(reader));
                wordValue=contentHandler.getWordValue();
                wordValue.setWord(searchedWord);
            }
        }catch(Exception e){
            e.printStackTrace();
        }
        return wordValue;
    }

//以下几个方法都是获得某个单词的某一项信息，基本的思路还是先获得全部信息WordValue然后调用WordValue的get方法获得具体的信息。
    //获取发音文件地址
    public String getPronEngUrl(String searchedWord){
        Cursor cursor=dbR.query(tableName, new String[]{"prone"}, "word=?", new String[]{searchedWord}, null, null, null);
        if(cursor.moveToNext()==false){
            cursor.close();
            return null;
        }
        String str=cursor.getString(cursor.getColumnIndex("prone"));
        cursor.close();
        return str;

    }

    public String getPronUSAUrl(String searchedWord){
        Cursor cursor=dbR.query(tableName, new String[]{"prona"}, "word=?", new String[]{searchedWord}, null, null, null);
        if(cursor.moveToNext()==false){
            cursor.close();
            return null;
        }
        String str=cursor.getString(cursor.getColumnIndex("prona"));
        cursor.close();
        return str;
    }

    //获取音标
    public String getPsEng(String searchedWord){
        Cursor cursor=dbR.query(tableName, new String[]{"pse"}, "word=?", new String[]{searchedWord}, null, null, null);
        if(cursor.moveToNext()==false){
            cursor.close();
            return null;
        }
        String str=cursor.getString(cursor.getColumnIndex("pse"));
        cursor.close();
        return str;
    }

    public String getPsUSA(String searchedWord){
        Cursor cursor=dbR.query(tableName, new String[]{"psa"}, "word=?", new String[]{searchedWord}, null, null, null);
        if(cursor.moveToNext()==false){
            cursor.close();
            return null;
        }
        String str=cursor.getString(cursor.getColumnIndex("psa"));
        cursor.close();
        return str;
    }

    /**
     * 若没有句子那么返回的链表的长度为0,若单词不存在那么直接返回null,所以最好对null和长度同时检验
     * @param searchedWord
     * @return
     */

    public String getInterpret(String searchedWord){
        Cursor cursor=dbR.query(tableName, new String[]{"interpret"}, "word=?", new String[]{searchedWord}, null, null, null);
        if(cursor.moveToNext()==false){
            cursor.close();
            return null;
        }
        String str=cursor.getString(cursor.getColumnIndex("interpret"));
        cursor.close();
        return str;

    }

}</pre>
<p>有了这个类以后大家可能会有一个比较明确的思路了，在接下来将UI时Activity中会实例化一个Dict对象，直接调用它的某些方法完成操作。</p>
<p>　　　　三、音频播放</p>
<p>　　当我们查到一个单词时，可能想听一听这个单词的发音，这时就需要根据数据库中prone/prona这一列的音频地址，从网络上获得音频输入流下载到SD卡，然后调用MediaPlayer播放音乐，这是一个一系列的动作，再后面背单词时因为要听单词的发音，会更多的用到这个操作，为此我封装了一个方法，专门完成这组操作。</p>
<pre>package com.carlos.music;

import java.io.InputStream;
import java.io.InputStreamReader;

import org.xml.sax.InputSource;

import com.carlos.internet.NetOperator;
import com.carlos.text_parser.JinShanContentHandler;
import com.carlos.text_parser.XMLParser;
import com.carlos.utils.FileUtils;
import com.carlos.wordcontainer.Dict;
import com.carlos.wordcontainer.WordValue;
import com.carlos.yueci.ReciteActivity;

import android.content.Context;
import android.media.MediaPlayer;
import android.net.Uri;

public class Mp3Player {
    public final static String MUSIC_ENG_RELATIVE_PATH="yueci/sounds/sounds_EN/";
    public final static String MUSIC_USA_RELATIVE_PATH="yueci/sounds/sounds_US/";
    public final static int ENGLISH_ACCENT=0;
    public final static int USA_ACCENT=1;

    public Context context=null;
    public String tableName=null;
    public MediaPlayer mediaPlayer=null;
    FileUtils fileU=null;
    Dict dict=null;
    public  boolean isMusicPermitted=true;     //用于对是否播放音乐进行保护性设置，当该变量为false时，可以阻止一次音乐播放

    public Mp3Player(Context context,String tableName){
        this.context=context;
        this.tableName=tableName;
        fileU=new FileUtils();
        dict=new Dict(context,tableName);
        isMusicPermitted=true;

    }
    /**
     * 首先先看一下SD卡上有没有，若有则播放，没有执行下一步
     * 看一下dict表中有没有单词的记录，若有，看一下发音字段是不是有美式发音或英式发音，若无则退出
     * 若没有字段记录，访问网络下载Mp3然后播放
     * 一个Activity中一般只能有一个Voice成员变量，对应的也就只有一个MediaPlayer对象，这样才能对播放
     * 状态进行有效控制
     * 该方法原则上只能在线程中调用
     * @param word
     * @param accent
     */
    public void playMusicByWord(String word , int accent,boolean isAllowedToUseInternet, boolean isPlayRightNow){
        if(word==null || word.length()&lt;=0)
            return;
        char[] wordArray=word.toCharArray();
        char initialCharacter=wordArray[0];

        String path=null;
        String pronUrl=null;
        WordValue w=null;

        if(accent==ENGLISH_ACCENT){
            path=MUSIC_ENG_RELATIVE_PATH;
        }else{
            path=MUSIC_USA_RELATIVE_PATH;
        }

        if(fileU.isFileExist(path+initialCharacter+"/","-$-"+word+".mp3")==false){
            if(isAllowedToUseInternet==false)
                return;
            //为了避免多次多个线程同时访问网络下载同一个文件，这里加了这么一个控制变量

            if(dict.isWordExist(word)==false){  //数据库中没有单词记录，从网络上进行同步
                if((w=dict.getWordFromInternet(word))==null){
                    return;
                }
                dict.insertWordToDict(w, true);
            }//能走到这一步说明从网上同步成功，数据库中一定存在单词记录

            if(accent==ENGLISH_ACCENT){
                pronUrl=dict.getPronEngUrl(word);
            }else{
                pronUrl=dict.getPronUSAUrl(word);
            }
            if(pronUrl==null ||pronUrl=="null"||pronUrl.length()&lt;=0)
                return;    //这说明网络上也没有对应发音，故退出
            //得到了Mp3地址后下载到文件夹中然后进行播放

            InputStream in=null;
            in = NetOperator.getInputStreamByUrl(pronUrl);
            if(in==null)
                return;
            if(fileU.saveInputStreamToFile(in, path+initialCharacter+"/","-$-"+word+".mp3")==false)
                return;
        }
        //走到这里说明文件夹里一定有响应的音乐文件，故在这里播放
        if(isPlayRightNow==false)
            return;

        /**
         * 这个方法存在缺点，可能因为同时new 了多个MediaPlayer对象，导致start方法失效，
         * 因此解决的方法是，使用同一个MediaPlayer对象，若一次播放时发现对象非空，那么先
         * 调用release()方法释放资源，再重新create
         */

        if(isMusicPermitted==false){
            return;
        }

        try{
            if(mediaPlayer!=null){
                if(mediaPlayer.isPlaying())
                    mediaPlayer.stop();
                mediaPlayer.release();
                mediaPlayer=null;     //为了防止mediaPlayer多次调用stop release，这里置空还是有必要
            }
            mediaPlayer=MediaPlayer.create(context, Uri.parse("file://"+fileU.getSDRootPath()
                    +path+initialCharacter+"/-$-"+word+".mp3"));
            mediaPlayer.start();

        }catch(Exception e){
            mediaPlayer.release();
            e.printStackTrace();
        }

    }

}</pre>

<pre>public void playMusicByWord(String word , int accent,boolean isAllowedToUseInternet, boolean isPlayRightNow){}

这个方法的基本逻辑：根据接受的单词word，先看&ldquo;词典&rdquo;（数据库）中有没有该单词记录，若没有，先调用dict的getWordFromInternet()获取单词信息存储进数据库&ldquo;词典&rdquo;中，然后根据对应的口音accent，获得prone或prona的地址，然后访问网络，讲Mp3下载到本地，然后调用MediaPlayer对象播放音乐。

需要注意的几点：　　形参中isAllowedToUseInternet 是用于控制是否允许访问网络，添加这个控制项是因为，我们在播放音乐时有时候不想让该方法访问网络，因为过多的县城访问网络可能会造成同时下载同一个音频，会造成线程阻塞或者下载的文件数据损坏。    isPlayeRightNow 是用于控制是否立即播放该MP3,因为在之后实现背单词功能时有时只需要把MP3文件下载下来，而并不需要立刻播放，例如背单词时给你中文意思和英文选项，此时就不能立即播放音乐，否则就知道选项是什么了。   注意到还有一个isMusicPermitted 参量这是个静态成员变量，这个参量是用来阻止一次播放的，比如我们背单词时，突然不想背了退出，此时可能单词的音频正好要播放，这时需要把isMusicPermitted置为false，否则会出现退出后仍播放单词发音的现象。

OK，添加了上述三个支持功能我们终于可以进行最后的进击&mdash;&mdash;&mdash;&mdash;搭建UI界面了。这里插一句题外话，虽然在写教程时我是先实现了上述五个功能然后再搭的界面，但实际开发时这两个工作是同时进行的，我喜欢先把简单的UI搭出来，然后再慢慢实现各个按钮的功能，遇到需要的后台支持再实现它，很难说这两种方法哪个效率高些，我觉得还是先搭一个粗略的框架，然后实现后台功能，然后再回过头来完善UI和后台功能，这其中要经过n次调试。 我这里之所以先给出了完整的后台功能是因为应用已经写完了，我想让整个开发过程的思路更清晰一些。

（二）UI搭建

一、布局文件：先给出一个总的布局文件然后我根据图片分析。</pre>

<pre>&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    android:background="#E5E6E0" &gt;

    &lt;RelativeLayout
        android:id="@+id/edit_text_dict_search_bar"
                android:layout_width="match_parent"
                android:layout_height="42dp"
                    android:layout_alignParentTop="true"
                android:background="#2C2C2C"
                android:focusable="true"
                android:focusableInTouchMode="true"
                  &gt;

                &lt;ImageButton
                    android:id="@+id/image_btn_dict_back_to_general"
                    android:layout_width="50dp"
                        android:layout_height="match_parent"
                        android:layout_marginTop="1dp"
                        android:layout_marginBottom="1dp"
                        android:layout_marginLeft="1dp"
                        android:layout_alignParentLeft="true"
                        android:layout_weight="5"
                        android:background="@android:color/transparent"
                        android:src="@drawable/btn_back_blue"/&gt;  

                &lt;ImageButton
                        android:id="@+id/image_btn_dict_search"
                        android:layout_width="50dp"
                        android:layout_height="match_parent"
                        android:layout_alignParentRight="true"
                        android:background="@android:color/transparent"
                        android:src="@android:drawable/ic_menu_search" /&gt;

                    &lt;EditText
                        android:paddingLeft="10dp"
                        android:id="@+id/edit_text_dict"
                        android:layout_toRightOf="@id/image_btn_dict_back_to_general"
                        android:layout_toLeftOf="@id/image_btn_dict_search"
                    android:layout_width="match_parent"
                    android:layout_height="match_parent"
                    android:layout_weight="1"
                    android:background="@drawable/edit_back"
                    android:inputType="text"
                    android:maxLines="1"
                    android:gravity="center_vertical"
                    android:hint="请在此输入单词"
                    android:textColor="#FCFDFE"
                    android:imeOptions="actionSearch"
                     /&gt;

                    &lt;ImageButton
                        android:id="@+id/image_btn_dict_delete_all"
                        android:layout_width="35dp"
                        android:layout_height="match_parent"
                        android:layout_marginTop="5dp"
                        android:layout_marginBottom="5dp"
                        android:layout_toLeftOf="@id/image_btn_dict_search"
                        android:scaleType="fitXY"
                        android:src="@drawable/delete_all"
                        android:background="@android:color/transparent"/&gt;

    &lt;/RelativeLayout&gt;

    &lt;TextView
        android:id="@+id/text_dict_word"
        android:layout_width="match_parent"
        android:layout_height="40dp"
        android:text="fabulous"
        android:gravity="bottom"
        android:textColor="#3B3C3D"
        android:textStyle="bold"
        android:textSize="24sp"
        android:layout_below="@id/edit_text_dict_search_bar"
        android:layout_marginTop="36dp"
        android:layout_marginLeft="22dp"
        android:layout_marginRight="22dp"
        android:layout_marginBottom="3dp"/&gt;

    &lt;ImageButton
        android:id="@+id/image_btn_dict_add_to_wordlist"
        android:layout_height="30dp"
        android:layout_marginTop="10dp"
        android:layout_marginRight="30dp"
        android:layout_width="30dp"
        android:layout_alignParentRight="true"
        android:layout_alignTop="@id/text_dict_word"
        android:src="@drawable/add_danciben"
        android:background="@android:color/transparent"
        android:scaleType="fitXY"/&gt;

    &lt;RelativeLayout
        android:id="@+id/phonetic_bar"
        android:layout_width="match_parent"
        android:layout_marginLeft="22dp"
        android:layout_height="40dp"
        android:layout_below="@id/text_dict_word"&gt;
        &lt;ImageButton
            android:id="@+id/image_btn_dict_horn_accent_eng"
            android:layout_height="match_parent"
            android:layout_marginTop="7dp"
            android:layout_marginBottom="7dp"
            android:layout_width="30dp"
            android:background="@android:color/transparent"
            android:src="@drawable/horn_dict"
            android:scaleType="fitCenter"
            /&gt;
        &lt;TextView
            android:id="@+id/text_dict_phosymbol_eng"
            android:layout_height="match_parent"
            android:layout_width="wrap_content"
            android:text="英[fanted]"
            android:gravity="center_vertical"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/image_btn_dict_horn_accent_eng"/&gt;
        &lt;TextView
            android:id="@+id/text_dict_phosymbol_divider"
            android:layout_height="match_parent"
            android:layout_width="50dp"
            android:text="/"
            android:gravity="center"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/text_dict_phosymbol_eng"/&gt;

        &lt;ImageButton
            android:id="@+id/image_btn_dict_horn_accent_usa"
            android:layout_height="match_parent"
            android:layout_marginTop="7dp"
            android:layout_marginBottom="7dp"
            android:layout_width="30dp"
            android:background="@android:color/transparent"
            android:src="@drawable/horn_dict"
            android:scaleType="fitCenter"
            android:layout_toRightOf="@id/text_dict_phosymbol_divider"
            /&gt;

        &lt;TextView
            android:id="@+id/text_dict_phosymbol_usa"
            android:layout_height="match_parent"
            android:layout_width="wrap_content"
            android:text="美[fan‘ted]"
            android:gravity="center_vertical"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/image_btn_dict_horn_accent_usa"/&gt;

    &lt;/RelativeLayout&gt;

    &lt;LinearLayout
        android:id="@+id/dict_interpret_divider"
        android:layout_height="20dp"
        android:layout_width="match_parent"
        android:layout_marginLeft="10dp"
        android:layout_below="@id/phonetic_bar"
        android:orientation="horizontal"&gt;
        &lt;ImageView
            android:layout_width="30dp"
            android:layout_height="match_parent"
            android:src="@drawable/right_cursor"/&gt;
        &lt;TextView
            android:layout_width="wrap_content"
            android:layout_height="match_parent"
            android:text="基本释义"
            android:textSize="14sp"
            android:textColor="#00A2DC"
            android:gravity="center_vertical"/&gt;

    &lt;/LinearLayout&gt;

    &lt;TextView
        android:id="@+id/text_dict_interpret"
        android:layout_below="@id/dict_interpret_divider"
        android:layout_width="match_parent"
        android:layout_margin="10dp"
        android:layout_height="80dp"
        android:background="@drawable/layer_list_dict_item_back"
        android:padding="12dp"
        android:text="不切实际的\nsrge了然于心fsfg"
        android:textSize="14sp"
        android:textColor="#3C3C3C"
        android:lineSpacingMultiplier="1.2"/&gt;

    &lt;LinearLayout
        android:id="@+id/dict_sentence_divider"
        android:layout_height="20dp"
        android:layout_width="match_parent"
        android:layout_marginLeft="10dp"
        android:layout_below="@id/text_dict_interpret"
        android:orientation="horizontal"&gt;
        &lt;LinearLayout
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            android:layout_weight="2"
            &gt;
            &lt;ImageView
                android:layout_width="30dp"
                android:layout_height="match_parent"
                android:src="@drawable/right_cursor"/&gt;
            &lt;TextView
                android:layout_width="wrap_content"
                android:layout_height="match_parent"
                android:text="例句"
                android:textSize="14sp"
                android:textColor="#00A2DC"
                android:gravity="center_vertical"/&gt;

        &lt;/LinearLayout&gt;

        &lt;RelativeLayout
            android:layout_height="match_parent"
            android:layout_width="match_parent"
            android:layout_weight="1"&gt;

            &lt;ImageView
                android:id="@+id/dict_jinshan_ico"
                android:layout_height="match_parent"
                android:layout_width="30dp"
                android:layout_alignParentRight="true"
                android:layout_marginRight="15dp"
                android:src="@drawable/jinshan_ico"/&gt;
            &lt;TextView
                android:layout_height="match_parent"
                android:layout_width="wrap_content"
                android:gravity="bottom"
                android:layout_toLeftOf="@id/dict_jinshan_ico"
                android:text="supported by iCIBA"
                android:textColor="#6C6C6C"
                android:textSize="10sp"/&gt;

        &lt;/RelativeLayout&gt;

    &lt;/LinearLayout&gt;

    &lt;ListView
        android:id="@+id/listview_dict_sentence"
        android:layout_below="@id/dict_sentence_divider"
        android:layout_width="match_parent"
        android:layout_marginTop="10dp"
        android:layout_marginLeft="10dp"
        android:layout_marginRight="10dp"
        android:padding="12dp"
         android:layout_height="wrap_content"
        android:layout_alignParentBottom="true"
        android:background="@drawable/layer_list_dict_item_back"
        android:divider="#8C8C8C"
        android:dividerHeight="0px"
        &gt;

    &lt;/ListView&gt;

&lt;/RelativeLayout&gt;</pre>
<p>是不是有点晕呢？我把布局分成几块就懂了。</p>
<p>Part One:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzU1MjcwNC8yMDE0MDgvMjYyMDI4NDk5ODUxNzE5LnBuZw==.jpg" /></p>
<pre>这是顶部的横条，这是一个RelativeLayout,里面有以后Back 按钮， 搜索按钮， 删除EditText内容的按钮，还有一个EditText,对应的代码如下：</pre>

<pre>    &lt;RelativeLayout
        android:id="@+id/edit_text_dict_search_bar"
                android:layout_width="match_parent"
                android:layout_height="42dp"
                    android:layout_alignParentTop="true"
                android:background="#2C2C2C"
                android:focusable="true"
                android:focusableInTouchMode="true"
                  &gt;

                &lt;ImageButton
                    android:id="@+id/image_btn_dict_back_to_general"
                    android:layout_width="50dp"
                        android:layout_height="match_parent"
                        android:layout_marginTop="1dp"
                        android:layout_marginBottom="1dp"
                        android:layout_marginLeft="1dp"
                        android:layout_alignParentLeft="true"
                        android:layout_weight="5"
                        android:background="@android:color/transparent"
                        android:src="@drawable/btn_back_blue"/&gt;  

                &lt;ImageButton
                        android:id="@+id/image_btn_dict_search"
                        android:layout_width="50dp"
                        android:layout_height="match_parent"
                        android:layout_alignParentRight="true"
                        android:background="@android:color/transparent"
                        android:src="@android:drawable/ic_menu_search" /&gt;

                    &lt;EditText
                        android:paddingLeft="10dp"
                        android:id="@+id/edit_text_dict"
                        android:layout_toRightOf="@id/image_btn_dict_back_to_general"
                        android:layout_toLeftOf="@id/image_btn_dict_search"
                    android:layout_width="match_parent"
                    android:layout_height="match_parent"
                    android:layout_weight="1"
                    android:background="@drawable/edit_back"
                    android:inputType="text"
                    android:maxLines="1"
                    android:gravity="center_vertical"
                    android:hint="请在此输入单词"
                    android:textColor="#FCFDFE"
                    android:imeOptions="actionSearch"
                     /&gt;

                    &lt;ImageButton
                        android:id="@+id/image_btn_dict_delete_all"
                        android:layout_width="35dp"
                        android:layout_height="match_parent"
                        android:layout_marginTop="5dp"
                        android:layout_marginBottom="5dp"
                        android:layout_toLeftOf="@id/image_btn_dict_search"
                        android:scaleType="fitXY"
                        android:src="@drawable/delete_all"
                        android:background="@android:color/transparent"/&gt;

    &lt;/RelativeLayout&gt;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzU1MjcwNC8yMDE0MDgvMjYyMDM1MDczOTE2Njg1LnBuZw==.jpg" /></p>
<pre>这一块就是TextView  ImageButton（加入单词本）进行的一个Relative布局，没什么特别之处：布局代码如下</pre>

<pre>&lt;TextView
        android:id="@+id/text_dict_word"
        android:layout_width="match_parent"
        android:layout_height="40dp"
        android:text="fabulous"
        android:gravity="bottom"
        android:textColor="#3B3C3D"
        android:textStyle="bold"
        android:textSize="24sp"
        android:layout_below="@id/edit_text_dict_search_bar"
        android:layout_marginTop="36dp"
        android:layout_marginLeft="22dp"
        android:layout_marginRight="22dp"
        android:layout_marginBottom="3dp"/&gt;

    &lt;ImageButton
        android:id="@+id/image_btn_dict_add_to_wordlist"
        android:layout_height="30dp"
        android:layout_marginTop="10dp"
        android:layout_marginRight="30dp"
        android:layout_width="30dp"
        android:layout_alignParentRight="true"
        android:layout_alignTop="@id/text_dict_word"
        android:src="@drawable/add_danciben"
        android:background="@android:color/transparent"
        android:scaleType="fitXY"/&gt;

    &lt;RelativeLayout
        android:id="@+id/phonetic_bar"
        android:layout_width="match_parent"
        android:layout_marginLeft="22dp"
        android:layout_height="40dp"
        android:layout_below="@id/text_dict_word"&gt;
        &lt;ImageButton
            android:id="@+id/image_btn_dict_horn_accent_eng"
            android:layout_height="match_parent"
            android:layout_marginTop="7dp"
            android:layout_marginBottom="7dp"
            android:layout_width="30dp"
            android:background="@android:color/transparent"
            android:src="@drawable/horn_dict"
            android:scaleType="fitCenter"
            /&gt;
        &lt;TextView
            android:id="@+id/text_dict_phosymbol_eng"
            android:layout_height="match_parent"
            android:layout_width="wrap_content"
            android:text="英[fanted]"
            android:gravity="center_vertical"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/image_btn_dict_horn_accent_eng"/&gt;
        &lt;TextView
            android:id="@+id/text_dict_phosymbol_divider"
            android:layout_height="match_parent"
            android:layout_width="50dp"
            android:text="/"
            android:gravity="center"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/text_dict_phosymbol_eng"/&gt;

        &lt;ImageButton
            android:id="@+id/image_btn_dict_horn_accent_usa"
            android:layout_height="match_parent"
            android:layout_marginTop="7dp"
            android:layout_marginBottom="7dp"
            android:layout_width="30dp"
            android:background="@android:color/transparent"
            android:src="@drawable/horn_dict"
            android:scaleType="fitCenter"
            android:layout_toRightOf="@id/text_dict_phosymbol_divider"
            /&gt;

        &lt;TextView
            android:id="@+id/text_dict_phosymbol_usa"
            android:layout_height="match_parent"
            android:layout_width="wrap_content"
            android:text="美[fan‘ted]"
            android:gravity="center_vertical"
            android:textColor="#6C6C6C"
            android:textSize="14sp"
            android:layout_toRightOf="@id/image_btn_dict_horn_accent_usa"/&gt;

    &lt;/RelativeLayout&gt;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzU1MjcwNC8yMDE0MDgvMjYyMDM4MDUzMTM3MDc1LnBuZw==.jpg" /></p>
<p>这是两个TextView ，释义的TextView使用了一个LayerList做背景，布局代码：</p>
<pre>&lt;LinearLayout
        android:id="@+id/dict_interpret_divider"
        android:layout_height="20dp"
        android:layout_width="match_parent"
        android:layout_marginLeft="10dp"
        android:layout_below="@id/phonetic_bar"
        android:orientation="horizontal"&gt;
        &lt;ImageView
            android:layout_width="30dp"
            android:layout_height="match_parent"
            android:src="@drawable/right_cursor"/&gt;
        &lt;TextView
            android:layout_width="wrap_content"
            android:layout_height="match_parent"
            android:text="基本释义"
            android:textSize="14sp"
            android:textColor="#00A2DC"
            android:gravity="center_vertical"/&gt;

    &lt;/LinearLayout&gt;

    &lt;TextView
        android:id="@+id/text_dict_interpret"
        android:layout_below="@id/dict_interpret_divider"
        android:layout_width="match_parent"
        android:layout_margin="10dp"
        android:layout_height="80dp"
        android:background="@drawable/layer_list_dict_item_back"
        android:padding="12dp"
        android:text="不切实际的\nsrge了然于心fsfg"
        android:textSize="14sp"
        android:textColor="#3C3C3C"
        android:lineSpacingMultiplier="1.2"/&gt;</pre>

<pre>layer_list_dict_item_back  layerList位于drawable文件夹中，可搜索layerlist的使用方法学习</pre>

<pre>&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;layer-list xmlns:android="http://schemas.android.com/apk/res/android" &gt;
    &lt;item &gt;
        &lt;shape &gt;
            &lt;corners android:radius="4dp"/&gt;
            &lt;solid android:color="#D0D0D0"/&gt;
        &lt;/shape&gt;
    &lt;/item&gt;
    &lt;item android:left="0.8dp" android:top="0dp" android:right="2dp" android:bottom="2dp"&gt;
        &lt;shape &gt;
            &lt;corners android:radius="4dp"/&gt;
            &lt;solid android:color="#FEFEFE"/&gt;
        &lt;/shape&gt;
    &lt;/item&gt;

&lt;/layer-list&gt;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzU1MjcwNC8yMDE0MDgvMjYyMDQyMTI2NzM1OTQzLnBuZw==.jpg" /></p>
<p>这是一个ListView,它也采用了layerlist作背景。</p>
<pre>&lt;LinearLayout
        android:id="@+id/dict_sentence_divider"
        android:layout_height="20dp"
        android:layout_width="match_parent"
        android:layout_marginLeft="10dp"
        android:layout_below="@id/text_dict_interpret"
        android:orientation="horizontal"&gt;
        &lt;LinearLayout
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            android:layout_weight="2"
            &gt;
            &lt;ImageView
                android:layout_width="30dp"
                android:layout_height="match_parent"
                android:src="@drawable/right_cursor"/&gt;
            &lt;TextView
                android:layout_width="wrap_content"
                android:layout_height="match_parent"
                android:text="例句"
                android:textSize="14sp"
                android:textColor="#00A2DC"
                android:gravity="center_vertical"/&gt;

        &lt;/LinearLayout&gt;

        &lt;RelativeLayout
            android:layout_height="match_parent"
            android:layout_width="match_parent"
            android:layout_weight="1"&gt;

            &lt;ImageView
                android:id="@+id/dict_jinshan_ico"
                android:layout_height="match_parent"
                android:layout_width="30dp"
                android:layout_alignParentRight="true"
                android:layout_marginRight="15dp"
                android:src="@drawable/jinshan_ico"/&gt;
            &lt;TextView
                android:layout_height="match_parent"
                android:layout_width="wrap_content"
                android:gravity="bottom"
                android:layout_toLeftOf="@id/dict_jinshan_ico"
                android:text="supported by iCIBA"
                android:textColor="#6C6C6C"
                android:textSize="10sp"/&gt;

        &lt;/RelativeLayout&gt;

    &lt;/LinearLayout&gt;

    &lt;ListView
        android:id="@+id/listview_dict_sentence"
        android:layout_below="@id/dict_sentence_divider"
        android:layout_width="match_parent"
        android:layout_marginTop="10dp"
        android:layout_marginLeft="10dp"
        android:layout_marginRight="10dp"
        android:padding="12dp"
         android:layout_height="wrap_content"
        android:layout_alignParentBottom="true"
        android:background="@drawable/layer_list_dict_item_back"
        android:divider="#8C8C8C"
        android:dividerHeight="0px"
        &gt;

    &lt;/ListView&gt;</pre>
<p>设计好布局文件后，我们很容易理解各个控件的作用，接下来我们就要写Activity子类，用于实例化各个控件，设置监听器，实现各个按钮的功能。</p>
<p>在写Activity之前，首先就成员变量的命名做一个说明，因为个Activity中的控件很多，如果随便命名很容易混乱，这里我采用了一种根据属性和类命名的方法，大家可以参考：</p>
<p>比如 上面有一个&ldquo;放大镜&rdquo;的搜索按钮，这是一个ImageButton 同时它是属于DictActivity的，它的功能是开始查单词，那么就将这个ImageButton对象命名为：</p>
<p>ImageButton &nbsp;imageBtnDictSearch=(ImageButton)findViewById(R.id.image_btn_dict_search);</p>
<p>在设置布局文件后把id也设置成相同的名字，这样就不会搞混了，根据我的经验这种命名方式非常高效。</p>
<p>下面就给出DictActivity类：</p>
<pre>package com.carlos.yueci;

import java.security.KeyStore;

import java.util.ArrayList;
import java.util.Currency;
import java.util.HashMap;

import com.carlos.adapter.DictSentenceListAdapter;
import com.carlos.database.DataBaseHelper;
import com.carlos.music.Mp3Player;
import com.carlos.yueci.R;
import com.carlos.wordcontainer.Dict;
import com.carlos.wordcontainer.WordValue;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.inputmethodservice.Keyboard.Key;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.text.method.ScrollingMovementMethod;
import android.view.KeyCharacterMap.KeyData;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.TextView.OnEditorActionListener;

public class DictActivity extends Activity{

    public TextView textDictWord=null;
    public TextView textDictPhonSymbolEng=null;
    public TextView textDictPhonSymbolUSA=null;
    public TextView textDictInterpret=null;
    public ListView listViewDictSentence=null;
    public ImageButton imageBtnDictAddToWordList=null;
    public ImageButton imageBtnDictHornEng=null;
    public ImageButton imageBtnDictHornUSA=null;
    public ImageButton imageBtnDictSerach=null;
    public ImageButton imageBtnDictBackToGeneral=null;
    public ImageButton imageBtnDictDelteEditText=null;

    public Button buttonDictDialogConfirm=null;
    public Button buttonDictDialogCancel=null;

    public EditText editTextDictSearch=null;

    public Dict dict=null;

    public WordValue w=null;

    public DataBaseHelper dbGlossaryHelper=null;
    public SQLiteDatabase dbGlossaryR=null;
    public SQLiteDatabase dbGlossaryW=null;

    public Mp3Player mp3Box=null;

    public static String searchedWord=null;

    public Handler dictHandler=null;

    public void initial(){
        textDictWord=(TextView) findViewById(R.id.text_dict_word);
        textDictInterpret=(TextView)findViewById(R.id.text_dict_interpret);
        textDictPhonSymbolEng=(TextView)findViewById(R.id.text_dict_phosymbol_eng);
        textDictPhonSymbolUSA=(TextView)findViewById(R.id.text_dict_phosymbol_usa);
        listViewDictSentence=(ListView)findViewById(R.id.listview_dict_sentence);

        imageBtnDictAddToWordList=(ImageButton)findViewById(R.id.image_btn_dict_add_to_wordlist);
        imageBtnDictBackToGeneral=(ImageButton)findViewById(R.id.image_btn_dict_back_to_general);
        imageBtnDictHornEng=(ImageButton)findViewById(R.id.image_btn_dict_horn_accent_eng);
        imageBtnDictHornUSA=(ImageButton)findViewById(R.id.image_btn_dict_horn_accent_usa);
        imageBtnDictSerach=(ImageButton)findViewById(R.id.image_btn_dict_search);
        imageBtnDictDelteEditText=(ImageButton)findViewById(R.id.image_btn_dict_delete_all);

        editTextDictSearch=(EditText)findViewById(R.id.edit_text_dict);
        editTextDictSearch.setOnEditorActionListener(new EditTextDictEditActionLis());
        dict=new Dict(DictActivity.this, "dict");
        mp3Box=new Mp3Player(DictActivity.this, "dict");
        dbGlossaryHelper=new DataBaseHelper(DictActivity.this, "glossary");
        dbGlossaryR=dbGlossaryHelper.getReadableDatabase();
        dbGlossaryW=dbGlossaryHelper.getWritableDatabase();

        dictHandler=new Handler(Looper.getMainLooper());

        //对searchedWord进行初始化
        Intent intent=this.getIntent();
        searchedWord=intent.getStringExtra("word");
        if(searchedWord==null)
            searchedWord="";
        //设置查找的文本
        textDictWord.setText(searchedWord);

    }

    /**
     * 该方法可能需要访问网络，因此放在线程里进行
     * @param word
     */
    public void searchWord(String word){
        //调用该方法后首先初始化界面
        dictHandler.post(new RunnableDictSetTextInterface(searchedWord, "", "", "", null, null));
        w=null;    //对w进行初始化
        if(dict.isWordExist(word)==false){  //数据库中没有单词记录，从网络上进行同步
            if((w=dict.getWordFromInternet(word))==null ||w.getWord().equals("")){
                return;
            }
                //错词不添加进词典
            dict.insertWordToDict(w, true);   //默认添加到词典中
        }//能走到这一步说明从网上同步成功，数据库中一定存在单词记录
        w=dict.getWordFromDict(word);
        if(w==null){             //这里又进一步做了保护,若词典中还是没有，那么用空字符串代替
            w=new WordValue();
        }
        String searchStr=w.getWord();
        String phoSymEng=w.getPsE();
        String phoSymUSA=w.getPsA();
        String interpret=w.getInterpret();
        ArrayList&lt;String&gt; sentList=w.getOrigList();  //一定不会是null
        ArrayList&lt;String&gt; sentInChineseList=w.getTransList();
        dictHandler.post(new RunnableDictSetTextInterface(searchedWord, phoSymEng, phoSymUSA, interpret, sentList, sentInChineseList));
        if(phoSymEng.equals("")==false &amp;&amp; phoSymUSA.equals("")==false){    //只有有音标时才去下载音乐

            mp3Box.playMusicByWord(searchedWord, Mp3Player.ENGLISH_ACCENT, true, false);
            mp3Box.playMusicByWord(searchedWord, Mp3Player.USA_ACCENT, true, false);

        }
    }

    public void setOnClickLis(){
        imageBtnDictBackToGeneral.setOnClickListener(new IBDictBackToGeneralClickLis() );
        imageBtnDictHornEng.setOnClickListener(new IBDictPlayMusicByAccentClickLis(Mp3Player.ENGLISH_ACCENT));
        imageBtnDictHornUSA.setOnClickListener(new IBDictPlayMusicByAccentClickLis(Mp3Player.USA_ACCENT));
        imageBtnDictAddToWordList.setOnClickListener(new IBDictAddWordToGlossaryClickLis());
        imageBtnDictDelteEditText.setOnClickListener(new IBDictDeleteEditTextClickLis());
        imageBtnDictSerach.setOnClickListener(new IBDictSearchClickLis());
    }

    public void showAddDialog(){
        if(searchedWord==null)
            return;
        AlertDialog dialog=new AlertDialog.Builder(DictActivity.this).create();
        dialog.show();
        Window window=dialog.getWindow();
        window.setContentView(R.layout.dialog_if_layout);
        buttonDictDialogConfirm=(Button)window.findViewById(R.id.dialog_confirm);
        buttonDictDialogCancel=(Button)window.findViewById(R.id.dialog_cancel);
        buttonDictDialogConfirm.setOnClickListener(new BDictDialogConfirmClickLis(dialog));
        buttonDictDialogCancel.setOnClickListener(new BDictDialogCancelClickLis(dialog));
        TextView dialogText=(TextView)window.findViewById(R.id.dialog_text);
        dialogText.setText("把"+searchedWord+"添加到单词本?");

    }

    public void insertWordToGlossary(){
        if(w==null || w.getInterpret().equals("")){
            Toast.makeText(DictActivity.this, "单词格式错误", Toast.LENGTH_SHORT).show();
            return;                   //若是不是有效单词，那么将不能添加到单词本
        }
        boolean isSuccess=dbGlossaryHelper.insertWordInfoToDataBase(searchedWord, w.getInterpret(), false);
        if(isSuccess){
            Toast.makeText(DictActivity.this, "添加成功", Toast.LENGTH_SHORT).show();
        }else{
            Toast.makeText(DictActivity.this, "单词已存在", Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        // TODO Auto-generated method stub
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_dict);

        initial();
        setOnClickLis();

        new ThreadDictSearchWordAndSetInterface().start();

    }

    @Override
    protected void onStart() {
        // TODO Auto-generated method stub
        super.onStart();
        mp3Box.isMusicPermitted=true;
    }

    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        mp3Box.isMusicPermitted=false;
        super.onPause();
    }

    public class ThreadDictSearchWordAndSetInterface extends Thread{

        @Override
        public void run() {
            // TODO Auto-generated method stub
            super.run();
            searchWord(searchedWord);
        }

    }

    public class RunnableDictSetTextInterface implements Runnable{
        String searchStr=null;
        String phoSymEng=null;
        String phoSymUSA=null;
        String interpret=null;
        ArrayList&lt;String&gt; sentList=null;
        ArrayList&lt;String&gt; sentInChineseList=null;

        public RunnableDictSetTextInterface(String searchStr, String phoSymEng,
                String phoSymUSA, String interpret, ArrayList&lt;String&gt; sentList,
                ArrayList&lt;String&gt; sentInChineseList) {
            super();
            this.searchStr = searchStr;
            this.phoSymEng = "英["+phoSymEng+"]";
            this.phoSymUSA = "美["+phoSymUSA+"]";
            this.interpret = interpret;
            this.sentList = sentList;
            this.sentInChineseList = sentInChineseList;
        }

        @Override
        public void run() {
            // TODO Auto-generated method stub
            textDictWord.setText(searchStr);
            textDictPhonSymbolEng.setText(phoSymEng);
            textDictPhonSymbolUSA.setText(phoSymUSA);
            textDictInterpret.setText(interpret);
            if(sentList==null ||sentInChineseList==null){     //对链表为空进行防护
            //    textDictSentence.setText("");
                return;
            }
            int count=0;
            if(sentList.size()&lt;=sentInChineseList.size()){
                count=sentList.size();
            }else{
                count=sentInChineseList.size();             //保护机制，这里取两者长度最小值，但一般二者长度相等
            }
            ArrayList&lt;HashMap&lt;String,Object&gt;&gt; list=new ArrayList&lt;HashMap&lt;String,Object&gt;&gt;();
            for(int i=0; i&lt;count;i++){
    //            sb.append(sentList.get(i)+"\n"+sentInChineseList.get(i)+"\n\n");
                HashMap&lt;String,Object&gt; map=new HashMap&lt;String, Object&gt;();
                map.put("sentence", sentList.get(i)+"\n"+sentInChineseList.get(i));
                list.add(map);
            }
    //        textDictSentence.setText(sb.toString());
            DictSentenceListAdapter adapter=new DictSentenceListAdapter(DictActivity.this, R.layout.dict_sentence_list_item, list, new String[]{"sentence"}, new int[]{R.id.text_dict_sentence_list_item});
            listViewDictSentence.setAdapter(adapter);

        }

    }

    class IBDictBackToGeneralClickLis implements OnClickListener{

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            DictActivity.this.finish();

        }

    }

    class IBDictPlayMusicByAccentClickLis implements OnClickListener{

        public int accentTemp=0;

        public IBDictPlayMusicByAccentClickLis(int accentTemp) {
            super();
            this.accentTemp = accentTemp;
        }

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub

            mp3Box.playMusicByWord(searchedWord, accentTemp, false, true);

        }

    }

    class IBDictAddWordToGlossaryClickLis implements OnClickListener{

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            showAddDialog();
        }

    }

    class IBDictDeleteEditTextClickLis implements OnClickListener{

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            editTextDictSearch.setText("");
        }

    }

    class BDictDialogConfirmClickLis implements OnClickListener{

        AlertDialog dialog=null;
        public BDictDialogConfirmClickLis(AlertDialog dialog){
            this.dialog=dialog;
        }
        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            insertWordToGlossary();
            dialog.cancel();
        }

    }

    class BDictDialogCancelClickLis implements OnClickListener{
        AlertDialog dialog=null;
        public BDictDialogCancelClickLis(AlertDialog dialog){
            this.dialog=dialog;
        }

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            dialog.cancel();
        }

    }

    class EditTextDictEditActionLis implements OnEditorActionListener{

        @Override
        public boolean onEditorAction(TextView arg0, int arg1, KeyEvent arg2) {
            // TODO Auto-generated method stub
            if(arg1==EditorInfo.IME_ACTION_SEARCH || arg2!=null&amp;&amp;arg2.getKeyCode()==KeyEvent.KEYCODE_ENTER){
                startSearch();
                return true;
            }

            return false;
        }

    }

    class IBDictSearchClickLis implements OnClickListener{

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            startSearch();

        }

    }

    public void startSearch(){

        String str=editTextDictSearch.getText().toString();
        if(str==null || str.equals(""))
            return;
        searchedWord=str;
        new ThreadDictSearchWordAndSetInterface().start();
        InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(editTextDictSearch.getWindowToken(), 0);

    }

}</pre>
<p>我把所有的findViewById全部放在了initial()方法中，方便调用；这个Activity类的主要目的就是给各个按钮设置监听器，这里对监听器类的命名我也做了一个统一的规定：</p>
<p>还是以&ldquo;搜索&rdquo;按钮为例：搜索按钮是一个ImageButton，是属于DictActivity类，是实现搜索功能，需要设置一个ClickListener,那么我们创建的一个OnClickListener实现类的名字就叫： &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; class &nbsp; &nbsp; &nbsp; IBDictSearchClickLis &nbsp; implements OnCLickListner{ &nbsp;};</p>
<p>这里还涉及到使用AlertDialog &nbsp;，关于使用方法可以百度之，比较简单，其余部分都是利用我前面介绍的5个后台类进行对单词的操作，各个函数的功能都有注释。</p>
<p>另外要注意在子线程中是不能操作UI的，这里需要DictActivity实例化一个Handler对象，通过Runnable向UI发送信息，不推荐用Message</p>
<p>这里单词的例句使用到了ListView，关于ListView 可以参考我去年写的两篇关于ListView的教程：</p>
<p><a href="http://www.cnblogs.com/carlos-vic/p/Carlos_V_Android_6.html" rel="external nofollow noreferrer">http://www.cnblogs.com/carlos-vic/p/Carlos_V_Android_5.html</a></p>
<p><a href="http://www.cnblogs.com/carlos-vic/p/Carlos_V_Android_6.html" rel="external nofollow noreferrer">http://www.cnblogs.com/carlos-vic/p/Carlos_V_Android_6.html</a></p>
<p>这里进把基本ListView所需要的ListItem的布局文件和适配器BaseAdapter贴上来，最最基本的一个ListView：</p>
<p>listItem布局文件：</p>
<pre>&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
     android:layout_width="match_parent"
     android:layout_height="wrap_content"
     android:orientation="vertical"
     android:paddingTop="8dp"
     android:paddingBottom="8dp"
     android:paddingLeft="3dp"
     android:paddingRight="3dp"
     android:background="@drawable/list_item_sentence_back" &gt;

    &lt;TextView
        android:id="@+id/text_dict_sentence_list_item"
        android:layout_width="match_parent"
        android:layout_height="wrap_content"
        android:gravity="center_vertical"
        android:textColor="#3C3C3C"
        android:textSize="14sp"/&gt;

&lt;/LinearLayout&gt;</pre>
<p>适配器类：</p>
<pre>package com.carlos.adapter;

import java.util.ArrayList;
import java.util.HashMap;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class DictSentenceListAdapter extends BaseAdapter{

    private Context context=null;
    private int resources;
    private ArrayList&lt;HashMap&lt;String,Object&gt;&gt; list=null;
    private String[] from;
    private int[] to;

    /**
     * 这里仿照的是SimpleAdapter的形参列表
     * @param context
     * @param Resources
     * @param list
     * @param from
     * @param to
     */

    public DictSentenceListAdapter(Context context, int resources,
            ArrayList&lt;HashMap&lt;String, Object&gt;&gt; list, String[] from, int[] to) {
        super();
        this.context = context;
        this.resources = resources;
        this.list = list;
        this.from = from;
        this.to = to;
    }

    @Override
    public int getCount() {
        // TODO Auto-generated method stub
        return list.size();
    }

    @Override
    public Object getItem(int arg0) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public long getItemId(int arg0) {
        // TODO Auto-generated method stub
        return arg0;
    }

    @Override
    public View getView(int position, View contentView, ViewGroup arg2) {
        // TODO Auto-generated method stub
        LayoutInflater inflater=LayoutInflater.from(context);
        contentView=inflater.inflate(resources, null);
        TextView text=(TextView)contentView.findViewById(to[0]);
        text.setText((String)(list.get(position).get(from[0])));
        return contentView;
    }

}</pre>
<p>　　这样，&ldquo;悦词-i背单词&rdquo;应用的查单词功能就完全实现了，另外这里的布局文件中用到了很多背景资源，</p>
<p>等所有UI搭建完成后我会把资源文件上传上来，今天的教程就到这里了~</p>
<pre>
</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:46:10 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>和我一起开发Android应用（三）——“悦词-i背单词”词典功能实现的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG8zNA0.html" rel="bookmark">和我一起开发Android应用（二）&mdash;&mdash;&OpenCurlyDoubleQuote;悦词-i背单词&rdquo;项目功能分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				好几天没有更新了,给关心这个系列的朋友们说声抱歉.今天我们开始第二节,项目功能分析.因为这个背单词软件虽说功能比较简单,但要真正实现起来也挺麻烦的.所以今天我们首先分析一下这个应用的功能,然后逐条慢慢实现. PS:这款应用已经上线91助手,百度移动应用和应用宝,有兴趣下来研究的可以百度搜索“悦词i背单词91”就可找到,我想真正用一下这个应用再看这个教程会有比较直观的理解.好废话不多讲,进入正题. 功能分析: 功能1.查单词. 实现方法:金山词霸开放平台提供了一个开放API,通过Http访问金山词			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49o7Zg0.html" rel="bookmark">和我一起开发Android应用（一）&mdash;&mdash;开发一款安卓多功能背单词软件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家好,很久没有在博客园写过东西.前一段时间尝试学过一段时间cocos2d,但是由于学习资料有限,文档较少,一直难有进展,因此在刚刚过去的三周里,我又回到了我的老本行:java ,Android.在假期里我算是正式开发了我的第一个安卓应用: i背单词.经过三个星期的磕磕绊绊,终于写出一个较稳定的版本,现在这款应用已经成功上架GooglePlay,并且很快会在百度移动应用和安智网上架.当然由于这款软件只是由我个人维护,我也不奢求会有多大的下载量了呵呵,但我想有必要把这短时间开发应用的体会做一个总结			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02Da2z4.html" rel="bookmark">和我一起开发Android应用（四）&mdash;&mdash;拓词算法分析和&OpenCurlyDoubleQuote;悦词&rdquo;词库解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天我们要部分实现背单词功能,在开始正题之前,还是附上背单词软件的下载链接:http://apk.91.com/Soft/Android/com.carlos.yueci-4.html 最近实验室有了任务,时间会紧些,因此这个项目要加快进度了. 首先把我在系列二中的功能分析拷贝过来: 功能2.背单词. 实现方法:这里要用到第二个数据库,背单词的词库.我们需要一个存放单词的TXT文件,通过解析这个TXT文件,将要背的单词解析并存进数据库中,然后根据一定的规        律弹出单词. 所用到的技术			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4Nv2B4.html" rel="bookmark">Android艺术开发探索第三章&mdash;&mdash;&mdash;&mdash;View的事件体系（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android艺术开发探索第三章----View的事件体系(下) 在这里就能学习到很多,主要还是对View的事件分发做一个体系的了解 一.View的事件分发 上篇大致的说了一下View的基础知识和滑动,现在我们再来聊聊一个比较核心的知识点,那就是事件分发了,而且他还是一个难点,我们更加应该掌握,View的滑动冲突一直都是很苦恼的,这里,我们就来一起探索一下 1.点击事件的传递规则 我们分析的点击事件可不是View.OnClickListener,而是我们MotionEvent,即点击事件,关于M			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVz55wM.html" rel="bookmark">一起来开发Android的天气软件（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				距离上一篇一起来开发Android天气软件二的时间又将近半个月了,之间一直因为有事而没有更新实在抱歉,最近会加快更新的步伐,争取在2015年到来前写完这系列的博文,上一章我们已经使用LitePal框架搭建好了我们所需的数据库,这一章的内容将主要完成关于从中国天气网获取数据的网络通信操作,之前有学习过Android开发的同学应该都知道,Android实现互联网通信主要有两种方法,一种使用HTTPURLCONNECTION,一种使用HttpClient的方式,而我们今天将使用不同于以上两种的方式,使			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Zeepg0.html" rel="bookmark">Android艺术开发探索第三章&mdash;&mdash;View的事件体系（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android艺术开发探索第三章----View的事件体系(上) 我们继续来看这本书,因为有点长,所以又分了上下,你在本片中将学习到 View基础知识 什么是View View的位置参数 MotionEvent和TouchSlop VelocityTracker,GestureDetector和Scroller View的滑动 使用scrollTo/scrollBy 使用动画 改变布局参数 各种滑动方式的对比 弹性滑动 使用Scroller 通过动画' 使用延时策略 这章的概念偏自定义View方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vWZy94.html" rel="bookmark">Android 自定义控件开发入门 （三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上两次我们从如何自定义控件讲起,列举了View的一些Api,说明了一些在自定义的时候,可以进行重写的方法,然后通过一个例子的两种写法向大家展示了最基本的自定义控件和我们要充分了解并积极重写View方法的精神,这次我们将继续进行学习! 现在请大家回想一下我们使用安卓原生控件时的感受,一个好的控件是可以在xml中进行各种属性的操作的,而自定义控件往往有一些特殊的需求,今天我要讲的就是安卓给自定义控件添加自定义的属性. 下面再给大家具体介绍一下如果自定义的View需要有自定义的属性我们该如何处理: 我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZqGal0.html" rel="bookmark">Android的三种开发类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				请支持原创,尊重原创,转载请注明出处:http://blog.csdn.net/kangweijian(来自kangweijian的csdn博客) Android移植开发 Android移植开发的最终目的是为了开发Android嵌入式产品,从开发者的角度来看,这种类型的开发以具有硬件系统为前提,在硬件系统的基础上构建Android软件系统.这种类型的开发工作在Android系统的底层.在软件系统方面,主要的工作集中在以下两个方面: Linux中的相关设备驱动程序 驱动程序是硬件和上层软件的接口,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMyN1e0.html" rel="bookmark">使用Kotlin开发Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				查看我的全部开源项目[开源实验室] 欢迎加入我的QQ群:[201055521],本博客客户端源码下载[请点击] 摘要 我首先声明我并没有使用Kotlin很长时间,我几乎是在学习的同时写了这些文章的.我并没有尝试任何其它的替 代语言,例如Go和Scala,所以如果你是真的考虑换一种开发语言的话,我建议你去搜索一下其他人对这些 语言的评价. 本文原创,转载请注明地址:http://blog.kymjs.com/ 正文 最近,新了解了一门编程语言,叫做Kotlin.Kotlin是Jetbrains公司			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AP78g3.html" rel="bookmark" class="title">Centos7系统配置上的变化（一）</a>
					<div>
						原文 Centos7系统配置上的变化(一) 安装后,一开始有点儿无力吐槽的感觉,变化这么大? 一.Runlevel 首先一条,原来一直用的CentOS-6.5-x86_64-minimal.iso光盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyZ2K4.html" rel="bookmark" class="title">【转】 Android中selector的使用</a>
					<div>
						引言 selector中文的意思选择器,在Android中常常用来作组件的背景,这样做的好处是省去了用代码控制实现组件在不同状态下不同的背景颜色或图片的变换.使用十分方便. selector的定义 s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2bXa3.html" rel="bookmark" class="title">解决百度网盘限速问题</a>
					<div>
						这个方案主要是利用脚本,在网页端点击下载大文件不会自动跳转到客户端,而是启用第三方下载软件(如迅雷).因此不会有限速问题,下载速度取决于网速和下载器.(参考greasyfork.org) 具体方法:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qoDl9M.html" rel="bookmark" class="title">unity代码加密for Android，mono编译</a>
					<div>
						uinty3d加密推荐几篇比较好的博客链接: http://www.cppcourse.com/u3d-encryption.html http://www.xuanyusong.com/archiv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5eQN3.html" rel="bookmark" class="title">Angular2学习笔记&mdash;&mdash;Observable</a>
					<div>
						Reactive Extensions for Javascript 诞生于几年前,随着angular2正式版的发布,它将会被更多开发者所认知.RxJs提供的核心是Observable对象,它是一个使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DzRRM.html" rel="bookmark" class="title">ubuntu&sol;mint 安装google的拼音输入法</a>
					<div>
						sudo apt-get install fcitx sudo apt-get install fcitx-googlepinyin im-config 即可完成google的输入法 重启计算机.在右 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62qLXM.html" rel="bookmark" class="title">成长2015</a>
					<div>
						2015,今年我已经25岁了,从最初少年到现在,曾经走过的路,失去的朋友,往日所有的一切在回忆的海洋一瞬间划过,年轻的心对路的迷茫,对友情的失望,对爱情的担心,对婚姻的恐惧,夹杂着成长的痛在记忆里一点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5l7b0.html" rel="bookmark" class="title">jdk安装配置</a>
					<div>
						参考 http://www.cnblogs.com/yinxiangpei/articles/2456123.html 默认安装在C:\ProgramFiles\Java\jdk1.7.0目录下环境变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1QNJ4.html" rel="bookmark" class="title">AsyncTask异步任务</a>
					<div>
						1.android线程 分类:①Main Thread(主线程又叫UI线程)     用来展示UI控件的    ②Worker Thread(工作线程,出主线程外其他的线程都叫工作线程) 耗时操作,比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZrkQZ3.html" rel="bookmark" class="title">&lbrack;dpdk&rsqb; SDK编译-简单扼要版</a>
					<div>
						0. 前提: 环境是CentOS7,archlinux编译有问题,不知道却什么. 1. 解压: [[email protected] dpdk]# tar Jxf dpdk-2.2.0.tar.xz  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qqm6E4.html" rel="bookmark" class="title">js二级联动</a>
					<div>
						&lt;body&gt;&lt;section&gt; &lt;a&gt;省份&lt;/a&gt; &lt;select id=&quot;province&quot;&gt; &lt;option  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkrOl4.html" rel="bookmark" class="title">CSS3 圆角（border-radius）</a>
					<div>
						前缀 -moz(例如 -moz-border-radius)用于Firefox -webkit(例如:-webkit-border-radius)用于Safari和Chrome. 例1 &lt;div ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZYZKM.html" rel="bookmark" class="title">自己的作品界面---类似360杀毒软件的界面</a>
					<div>
						自己的作品界面---类似360杀毒软件的界面 软件界面,虽然有点丑,对比起我做的第一个几近黑白的界面来说,已经进步很大了(这是第二个).刚说要做界面的时候,我有种被雷击中的感觉,用java蛮久了,从来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPv2wB3.html" rel="bookmark" class="title">C语言变量的类型和存储位置</a>
					<div>
						1. C语言变量主要分为全局变量.静态全局变量.局部变量.静态局部变量和寄存器变量.其中静态变量用static关键字进行修饰.程序所占用的内存可以分为以下几个部分: (1)代码段-存放程序代码,只读的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qG1yPM.html" rel="bookmark" class="title">lvs的工作模型及调度算法</a>
					<div>
						lvs:linux virtual server  基于端口的高并发负载均衡器 工作与tcp层,软件实现方式 工作原理:当数据包经过prerouting进入input链,如果请求的是定义为集群服务的服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wkPg0.html" rel="bookmark" class="title">开发中常用颜色的 rgb 值</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyW1rM.html" rel="bookmark" class="title">lamp 安装教程</a>
					<div>
						https://github.com/teddysun/lamp http://teddysun.com/lamp 两篇文章基本一样,大家可以用来参考.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1nzJ3.html" rel="bookmark" class="title">以继承方式让EF使用泛型</a>
					<div>
						Entity Framework 无法直接使用泛型,但是我们可以通过使用继承的办法来间接使用泛型. Imports System.Data.Entity Imports System.Componen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnGLa4.html" rel="bookmark" class="title">Swift实现截屏并保存相册</a>
					<div>
						func saveToLocal() { //截屏 let screenRect = UIScreen.mainScreen().bounds UIGraphicsBeginImageContext( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQDDZM.html" rel="bookmark" class="title">L003-oldboy-mysql-dba-lesson03</a>
					<div>
						IOPS:每秒钟输入输出的数量 [[email protected] ~]# cat /proc/meminfo [[email protected] ~]# cat /proc/cpuinfo [[ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
